#include "__dump.h"
#include "Exception.h"
#include <iostream>
#include <fstream>

namespace jet {

   __dump::__dump(coreutils::ZString &in, coreutils::MString &parentOut, Global &global, Tag *parent) : Tag(in, parentOut, global, parent) {
      if(!variableDefined("file"))
	throw coreutils::Exception("file must be sppecified for dump tag.");

      std::ofstream outFile(variables["file"].str());

      outFile << "*** CGI VARIABLES ***" << std::endl;
      
      for (auto i = global.cgiVariables.begin(); i != global.cgiVariables.end(); i++)
	outFile << i->first << "=[" << i->second << "]" << std::endl;

      outFile << "*** GLOBAL VARIABLES ***" << std::endl;
      
      for (auto i = global.variables.begin(); i != global.variables.end(); i++)
	outFile << i->first << "=[" << i->second << "]" << std::endl;

      outFile << "*** LOCAL VARIABLES ***" << std::endl;
      
      for (auto i = parent->variables.begin(); i != parent->variables.end(); i++)
	outFile << i->first << "=[" << i->second << "]" << std::endl;

      outFile.close();
      
   }
   
}
